require("cmd_helpers")
require("isapi_base")

caps = {
    requests = {
        ["device.ctl.relay_output.trigger"] = {
            handler = "trigger_relay_output"
        }
    }
}

function trigger_relay_output_impl(state, port)
    local alarm_mode = (state == relay.ACTIVE and "high" or "low")
    local url = string.format("/ISAPI/System/IO/outputs/%s/trigger", port)
    local request = string.format("<IOPortData><outputState>%s</outputState></IOPortData>", alarm_mode)
    local response = xml_request(url, "PUT", request)

    if response and response.ResponseStatus.statusString["#text"] == "OK" then
        return true
    end
end

function trigger_relay_output(cmd)
    return relay.trigger_output(cmd, trigger_relay_output_impl)
end

init()